package cn.superdesk.uniorder.executor.scheduler.kafka._thirdpart.qchjc._constants.enums;

import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 2022/5/10 11:48 上午
 * @UpdateUser: linjinyu
 * @UpdateDate: 2022/5/10 11:48 上午
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public enum QchjcSupplierStatementEventEnum {


    // 触发事件点;
    //  1.来源于“企业商城”的对账单在**“积分结算-发票登记管理-【收票登记】”成功时**：若该对账单所有有效的开票申请的申请状态均为“待付款”时；
    收票状态同步("receiveInvoiceStatusSync", "客户结算"),

    // 触发事件点;
    //  1. 来源于“企业商城”的对账单在**“供应商结算-货款管理-【确认付款】”成功时**：若该对账单的所有有效的开票申请的申请状态均为“已付款”时；（“付款中”状态无需同步。）
    付款状态同步("paymentStatusSync", "积分结算"),

    // 触发事件点;
    //  1. 来源于“企业商城”的对账单在**“供应商结算-对账单-【重新对账】”成功时**；
    账单作废同步("statementCancelSync", "供应商结算"),
    ;

    private String key;
    private String desc;

    QchjcSupplierStatementEventEnum(String key, String desc) {
        this.key = key;
        this.desc = desc;
    }

    public String getKey() {
        return key;
    }

    public String getDesc() {
        return desc;
    }

    public static String getDesc(String key) {
        for (QchjcSupplierStatementEventEnum c : QchjcSupplierStatementEventEnum.values()) {
            if (c.key.equals(key)) {
                return c.getDesc();
            }
        }

        return "未知事件";
    }

    private static final Map<String, QchjcSupplierStatementEventEnum> LOOKUP = new HashMap<>();

    static {
        for (QchjcSupplierStatementEventEnum s : EnumSet.allOf(QchjcSupplierStatementEventEnum.class)) {
            LOOKUP.put(s.getKey(), s);
        }
    }

    public static QchjcSupplierStatementEventEnum get(String key) {
        return LOOKUP.get(key);
    }
}
